"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var Runner_1 = require("./Runner");
var createColosseumActions = function (runner) { return ({
    add: function (payload) { return runner.add(payload.name, payload.url); },
    remove: function (payload) { return runner.remove(payload.name); },
    running: function (payload) { return runner.running(payload.key); },
    services: function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = [
                        { name: 'colosseum', running: true }
                    ]).concat;
                    return [4 /*yield*/, runner.getServices()];
                case 1: return [2 /*return*/, _b.apply(_a, [(_c.sent())])];
            }
        });
    }); },
    update: function (payload) { return runner.update(payload.name); },
}); };
var createColosseumMessenger = function (runner) { return function (messageName, payload) { return __awaiter(_this, void 0, void 0, function () {
    var actions, action, response, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                actions = createColosseumActions(runner);
                _a.label = 1;
            case 1:
                _a.trys.push([1, 4, , 5]);
                action = actions[messageName];
                if (!action) return [3 /*break*/, 3];
                return [4 /*yield*/, action(payload)];
            case 2:
                response = _a.sent();
                return [2 /*return*/, { success: true, response: response }];
            case 3: return [2 /*return*/, { success: false, response: 'Invalid message' }];
            case 4:
                error_1 = _a.sent();
                return [2 /*return*/, { success: false, response: error_1.message }];
            case 5: return [2 /*return*/];
        }
    });
}); }; };
var Envoy = function (system, installDirectory) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    var message, runner, colosseumMessage;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, system.ensureDirectory(installDirectory)];
            case 1:
                _a.sent();
                message = function (name, messageName, payload) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        if (name === 'colosseum') {
                            return [2 /*return*/, colosseumMessage(messageName, payload)];
                        }
                        return [2 /*return*/, runner.message(name, messageName, payload)];
                    });
                }); };
                return [4 /*yield*/, Runner_1.default(system, message, installDirectory)];
            case 2:
                runner = _a.sent();
                colosseumMessage = createColosseumMessenger(runner);
                return [2 /*return*/, {
                        message: message,
                    }];
        }
    });
}); };
exports.default = Envoy;
//# sourceMappingURL=Envoy.js.map