"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var createRunnerServer_1 = require("./helpers/createRunnerServer");
var generateKey_1 = require("./helpers/generateKey");
var Runner = function (system, messageHandler, installDirectory) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    var services, serverPort, nextPort, getDirectory, getService, start, register, registerInstalled, add, remove, running, getServices, update, message, load;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                services = [];
                serverPort = 8000;
                nextPort = serverPort + 1;
                getDirectory = function (name) { return path_1.join(installDirectory, "colosseum-" + name); };
                getService = function (name) { return services.find(function (service) { return service.name === name; }); };
                start = function (name, key, port) { return __awaiter(_this, void 0, void 0, function () {
                    var directory;
                    return __generator(this, function (_a) {
                        directory = path_1.join(getDirectory(name), 'node_modules', name);
                        return [2 /*return*/, system.startProcess('node', [
                                path_1.join(__dirname, './indexService'),
                                "--path=" + directory,
                                "--key=" + key,
                                "--port=" + port,
                                "--host=http://localhost:" + serverPort,
                            ])];
                    });
                }); };
                register = function (name) { return __awaiter(_this, void 0, void 0, function () {
                    var key, port, stop;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, generateKey_1.default()];
                            case 1:
                                key = _a.sent();
                                port = nextPort++;
                                return [4 /*yield*/, start(name, key, port)];
                            case 2:
                                stop = _a.sent();
                                services.push({ name: name, key: key, port: port, stop: stop, running: false });
                                return [2 /*return*/];
                        }
                    });
                }); };
                registerInstalled = function () { return __awaiter(_this, void 0, void 0, function () {
                    var installed, _i, installed_1, name;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, system.listDirectories(installDirectory)];
                            case 1:
                                installed = _a.sent();
                                _i = 0, installed_1 = installed;
                                _a.label = 2;
                            case 2:
                                if (!(_i < installed_1.length)) return [3 /*break*/, 5];
                                name = installed_1[_i];
                                return [4 /*yield*/, register(name.replace(/^colosseum-/, ''))];
                            case 3:
                                _a.sent();
                                _a.label = 4;
                            case 4:
                                _i++;
                                return [3 /*break*/, 2];
                            case 5: return [2 /*return*/];
                        }
                    });
                }); };
                add = function (name, url) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (getService(name)) {
                                    throw new Error("Service with name " + name + " already exists.");
                                }
                                return [4 /*yield*/, system.createProject(installDirectory, "colosseum-" + name)];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, system.install(getDirectory(name), url)];
                            case 2:
                                _a.sent();
                                return [4 /*yield*/, register(name)];
                            case 3:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); };
                remove = function (name) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, system.deleteDirectory(getDirectory(name))];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, services.splice(services.findIndex(function (x) { return x.name === name; }), 1)];
                            case 2:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); };
                running = function (key) { return __awaiter(_this, void 0, void 0, function () {
                    var service;
                    return __generator(this, function (_a) {
                        service = services.find(function (s) { return s.key === key; });
                        if (!service) {
                            throw new Error('Invalid key');
                        }
                        service.running = true;
                        return [2 /*return*/];
                    });
                }); };
                getServices = function () { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2 /*return*/, services.map(function (x) { return ({
                                name: x.name,
                                running: x.running,
                            }); })];
                    });
                }); };
                update = function (name) { return __awaiter(_this, void 0, void 0, function () {
                    var service, stop;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                service = getService(name);
                                if (!service) {
                                    throw new Error("Service " + name + " not registered.");
                                }
                                return [4 /*yield*/, service.stop()];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, system.update(getDirectory(name), name)];
                            case 2:
                                _a.sent();
                                return [4 /*yield*/, start(name, service.key, service.port)];
                            case 3:
                                stop = _a.sent();
                                service.stop = stop;
                                return [2 /*return*/];
                        }
                    });
                }); };
                message = function (name, messageName, payload) { return __awaiter(_this, void 0, void 0, function () {
                    var service, url, _a, body, status;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                service = getService(name);
                                if (!service) {
                                    return [2 /*return*/, { success: false, response: "Service " + name + " not registered." }];
                                }
                                url = "http://localhost:" + service.port + "/" + messageName + "/" + service.key;
                                return [4 /*yield*/, system.post(url, payload)];
                            case 1:
                                _a = _b.sent(), body = _a.body, status = _a.status;
                                return [2 /*return*/, { success: status === 200, response: body }];
                        }
                    });
                }); };
                load = function () { return __awaiter(_this, void 0, void 0, function () {
                    var authenticate, server;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, registerInstalled()];
                            case 1:
                                _a.sent();
                                authenticate = function (key) { return Boolean(services.find(function (service) { return service.key === key; })); };
                                server = createRunnerServer_1.default(authenticate, messageHandler);
                                return [4 /*yield*/, system.serve(server, serverPort)];
                            case 2:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); };
                return [4 /*yield*/, load()];
            case 1:
                _a.sent();
                return [2 /*return*/, {
                        add: add,
                        getServices: getServices,
                        message: message,
                        remove: remove,
                        running: running,
                        update: update,
                    }];
        }
    });
}); };
exports.default = Runner;
//# sourceMappingURL=Runner.js.map