"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = require("fs-extra");
var path_1 = require("path");
var request = require("request");
var NPM = require("./npm");
var process_1 = require("./process");
var ls = require('ls'); // tslint:disable-line no-var-requires
var ncu = require('npm-check-updates'); // tslint:disable-line no-var-requires
var createProject = function (directory, name) { return __awaiter(_this, void 0, void 0, function () {
    var projectDirectory;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                projectDirectory = path_1.join(directory, name);
                fs_extra_1.emptyDirSync(projectDirectory);
                return [4 /*yield*/, NPM.init(projectDirectory)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var deleteDirectory = function (directory) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        fs_extra_1.removeSync(directory);
        return [2 /*return*/];
    });
}); };
var ensureDirectory = function (directory) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        fs_extra_1.ensureDirSync(directory);
        return [2 /*return*/];
    });
}); };
var install = function (directory, url) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, NPM.installDependency(directory, url)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var listDirectories = function (directory) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, ls(path_1.join(directory, '*'))
                .filter(function (file) { return fs_extra_1.lstatSync(file.full).isDirectory(); })
                .map(function (file) { return file.name; })];
    });
}); };
var post = function (url, requestBody) {
    return new Promise(function (resolve, reject) {
        request.post(url, { json: requestBody }, function (error, response, responeBody) {
            if (error) {
                reject(error);
            }
            else {
                resolve({ status: response.statusCode, body: responeBody });
            }
        });
    });
};
var serve = function (server, port) {
    return new Promise(function (resolve) {
        return server.listen(port, function () {
            resolve();
        });
    });
};
var startProcess = function (command, args) { return __awaiter(_this, void 0, void 0, function () {
    var childProcess;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, process_1.start(command, args, process.cwd(), console.log, console.error, function () { return null; })];
            case 1:
                childProcess = _a.sent();
                return [2 /*return*/, childProcess.stop];
        }
    });
}); };
var update = function (directory, name) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, deleteDirectory(path_1.join(directory, 'node_modules'))];
            case 1:
                _a.sent();
                return [4 /*yield*/, NPM.install(directory)];
            case 2:
                _a.sent();
                return [4 /*yield*/, ncu.run({
                        packageFile: path_1.join(directory, 'package.json'),
                        silent: true,
                    })];
            case 3:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var System = {
    createProject: createProject,
    deleteDirectory: deleteDirectory,
    ensureDirectory: ensureDirectory,
    install: install,
    listDirectories: listDirectories,
    post: post,
    serve: serve,
    startProcess: startProcess,
    update: update,
};
exports.default = System;
//# sourceMappingURL=System.js.map