"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var start = function (command, args, directory, onOutput, onError, onStopped) {
    var internalOnStopped;
    var process = child_process_1.spawn(command, args, {
        cwd: directory,
    });
    process.stdout.on('data', function (data) {
        if (onOutput) {
            onOutput(data.toString().trim());
        }
    });
    process.stderr.on('data', function (data) {
        if (onError) {
            onError(data.toString().trim());
        }
    });
    process.on('close', function (code) {
        if (onStopped) {
            onStopped(code);
        }
        if (internalOnStopped) {
            internalOnStopped();
        }
    });
    var stop = function () {
        return new Promise(function (resolve) {
            internalOnStopped = resolve;
            process.kill();
        });
    };
    return {
        stop: stop,
    };
};
exports.start = start;
var run = function (command, args, directory, onOutput, onError) {
    return new Promise(function (resolve) {
        start(command, args, directory, onOutput, onError, resolve);
    });
};
exports.run = run;
//# sourceMappingURL=process.js.map