import Poster from '../types/Poster';

const createMessenger = (host: string, key: string, poster: Poster) => {
  const message = async (serviceName: string, messageName: string, payload: any) => {
    const requestUrl = `${host}/${serviceName}/${messageName}/${key}`;
    const { error, body } = await poster(requestUrl, payload);
    if (error) {
      throw error;
    } else if (body) {
      if (body.success) {
        return body.response;
      } else {
        throw new Error(body.error);
      }
    } else {
      throw new Error('Invalid response');
    }
  };

  return message;
};

export default createMessenger;
