import * as bodyParser from 'body-parser';
import * as express from 'express';

const createServer = (
  authenticate: (key: string) => boolean,
  handle: (service: string, messageName: string, payload: any) => Promise<any>,
) => {
  const server = express();

  server.use(bodyParser.json());

  server.post('/:service/:messageName/:key', async (req, res) => {
    if (authenticate(req.params.key)) {
      res.json(await handle(req.params.service, req.params.messageName, req.body));
    } else {
      res.status(403).send('🖕');
    }
  });

  return server;
};

export default createServer;
