const ARG_PATTERN = /--([^-=\s]+)=([^=\s]+)/;

const getArgs = (rawArgs: string[]) => {
  const args: { [Key: string]: string } = {};

  rawArgs.forEach(arg => {
    const matches = ARG_PATTERN.exec(arg);
    if (matches) {
      args[matches[1]] = matches[2];
    }
  });

  return args;
};

export default getArgs;
