import Envoy from './Envoy';
import Server from './Server';
import System from './system/System';

interface IOptions {
  port: number;
  secret: string;
  hash: string;
  installDirectory: string;
}

const start = async (options: IOptions) => {
  const envoy = await Envoy(System, options.installDirectory);
  const server = await Server(envoy.message, options.secret, options.hash);
  await System.serve(server, options.port);
  return envoy.message;
};

export default start;
