import { Express } from 'express';
import { post } from 'request';

import Service from './Service';
import Poster from './types/Poster';

const poster: Poster = (url: string, postBody: any) =>
  new Promise((resolve, reject) => {
    post(url, { json: postBody }, (error, response, body) => {
      resolve({ error, body });
    });
  });

const loader = async (path: string) => require(path);

const listener = (server: Express, port: number) =>
  new Promise<void>(resolve =>
    server.listen(port, () => {
      resolve();
    }),
  );

const start = async () => {
  await Service(process.argv, poster, loader, listener);
};

start().catch(console.error);
