import { Express } from 'express';

interface ISystem {
  createProject(directory: string, name: string): Promise<void>;
  deleteDirectory(directory: string): Promise<void>;
  ensureDirectory(directory: string): Promise<void>;
  install(directory: string, url: string): Promise<void>;
  listDirectories(directory: string): Promise<string[]>;
  startProcess(command: string, args: string[]): Promise<() => Promise<void>>;
  post(url: string, body: any): Promise<{ body: string; status: number }>;
  serve(server: Express, port: number): Promise<void>;
  update(directory: string, name: string): Promise<void>;
}

export default ISystem;
